import 'package:flutter/material.dart';

class IRootNavigator extends StatefulWidget {
  final GlobalKey<NavigatorState> navigatorKey;
  final List<Page> pages;

  const IRootNavigator({
    required this.navigatorKey,
    required this.pages,
    Key? key,
  }) : super(key: key);

  @override
  _IRootNavigatorState createState() => _IRootNavigatorState();
}

class _IRootNavigatorState extends State<IRootNavigator> {
  @override
  Widget build(BuildContext context) {
    return Navigator(
        key: widget.navigatorKey,
        onPopPage: (route, dynamic result) {
          return route.didPop(result);
        },
        pages: widget.pages);
  }
}
