import 'package:flutter/material.dart';
import '../irouter.dart';

class ITabNavigator extends StatelessWidget {
  static GlobalKey<NavigatorState> navigatorKey = GlobalKey<NavigatorState>();
  final List<String> urls;
  final String tabId;
  final int index;

  const ITabNavigator(
      {Key? key, required this.urls, this.tabId = 'ipage', this.index = 0})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    var routeState = IRouterScope.of(context);

    routeState.addTab(tabId, urls);
    if (routeState.route.pattern != routeState.tabs[tabId]![index].url) {
      routeState.tabs[tabId]![index].currentUrl = routeState.route.path;
    }
    if (routeState.tabs[tabId]![index].defaultPage == null) {
      routeState.tabs[tabId]![index].defaultPage =
          routeState.getPage(routeState.tabs[tabId]![index].url);
    }
    return Navigator(
      key: navigatorKey,
      onPopPage: (route, dynamic result) {
        routeState.to(routeState.tabs[tabId]![index].url, index, tabId);
        return route.didPop(result);
      },
      pages: [
        routeState.tabs[tabId]![index].defaultPage!,
        if (routeState.route.pattern != routeState.tabs[tabId]![index].url)
          routeState.getPage()
      ],
    );
  }
}
